<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "partner_site_entity".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "PartnerSiteEntity".
 *
 * Columns in table "partner_site_entity" available as properties of the model,
 * followed by relations of table "partner_site_entity" available as properties of the model.
 *
 * @property integer $id
 * @property integer $sort_order
 * @property integer $partner_site_id
 * @property string $name
 * @property string $dump_query
 * @property string $event_query
 * @property string $structure
 * @property string $mapping
 * @property integer $public
 * @property integer $page_size
 *
 * @property PartnerSite $partnerSite
 * @property PartnerSiteEntityEvent[] $partnerSiteEntityEvents
 */
abstract class BasePartnerSiteEntity extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'partner_site_entity';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'PartnerSiteEntity|PartnerSiteEntities', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('sort_order, name, page_size', 'required'),
            array('sort_order, partner_site_id, public, page_size', 'numerical', 'integerOnly' => true),
            array('name', 'length', 'max' => 255),
            array('dump_query, event_query, structure', 'safe'),
            array('partner_site_id, dump_query, event_query, structure, mapping, public', 'default',
                'setOnEmpty' => true, 'value' => null),
            array('id, sort_order, partner_site_id, name, dump_query, event_query, structure, mapping, '
                . 'public, page_size', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'partnerSite' => array(self::BELONGS_TO, 'PartnerSite', 'partner_site_id'),
            'partnerSiteEntityEvents' => array(self::HAS_MANY, 'PartnerSiteEntityEvent', 'partner_site_entity_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'sort_order' => Yii::t('app', 'Sort Order'),
            'partner_site_id' => null,
            'name' => Yii::t('app', 'Name'),
            'dump_query' => Yii::t('app', 'Dump Query'),
            'event_query' => Yii::t('app', 'Event Query'),
            'structure' => Yii::t('app', 'Structure'),
            'mapping' => Yii::t('app', 'Mapping'),
            'public' => Yii::t('app', 'Public'),
            'page_size' => Yii::t('app', 'Page Size'),
            'partnerSite' => null,
            'partnerSiteEntityEvents' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('sort_order', $this->sort_order);
        $criteria->compare('partner_site_id', $this->partner_site_id);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('dump_query', $this->dump_query, true);
        $criteria->compare('event_query', $this->event_query, true);
        $criteria->compare('structure', $this->structure, true);
        $criteria->compare('mapping', $this->mapping, true);
        $criteria->compare('public', $this->public);
        $criteria->compare('page_size', $this->page_size);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
